VERSION 5.00
Begin VB.Form FRat 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Rational Number Demo"
   ClientHeight    =   3435
   ClientLeft      =   1080
   ClientTop       =   1500
   ClientWidth     =   4665
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   3435
   ScaleWidth      =   4665
   Begin VB.CheckBox Check2 
      Caption         =   "AutoReduce Fractions"
      Height          =   195
      Left            =   2460
      TabIndex        =   13
      Top             =   2040
      Value           =   1  'Checked
      Width           =   2055
   End
   Begin VB.CheckBox Check1 
      Caption         =   "Show Whole Portion"
      Height          =   195
      Left            =   2460
      TabIndex        =   12
      Top             =   1740
      Width           =   2055
   End
   Begin VB.CommandButton Command1 
      Cancel          =   -1  'True
      Caption         =   "Exit"
      Height          =   375
      Index           =   1
      Left            =   3420
      TabIndex        =   15
      Top             =   2880
      Width           =   1095
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Recalc"
      Default         =   -1  'True
      Height          =   375
      Index           =   0
      Left            =   3420
      TabIndex        =   14
      Top             =   2400
      Width           =   1095
   End
   Begin VB.Frame frmCRat2 
      Caption         =   "CRat2"
      Height          =   1155
      Left            =   2400
      TabIndex        =   5
      Top             =   180
      Width           =   2055
      Begin VB.TextBox Text3 
         Height          =   315
         Index           =   1
         Left            =   1200
         TabIndex        =   9
         Text            =   "Text3"
         Top             =   660
         Width           =   675
      End
      Begin VB.TextBox Text3 
         Height          =   315
         Index           =   0
         Left            =   1200
         TabIndex        =   7
         Text            =   "Text3"
         Top             =   240
         Width           =   675
      End
      Begin VB.Label Label3 
         Alignment       =   1  'Right Justify
         AutoSize        =   -1  'True
         Caption         =   "Numerator:"
         Height          =   195
         Index           =   0
         Left            =   300
         TabIndex        =   6
         Top             =   300
         Width           =   780
      End
      Begin VB.Label Label3 
         Alignment       =   1  'Right Justify
         AutoSize        =   -1  'True
         Caption         =   "Denominator:"
         Height          =   195
         Index           =   1
         Left            =   135
         TabIndex        =   8
         Top             =   720
         Width           =   945
      End
   End
   Begin VB.Frame frmCRat1 
      Caption         =   "CRat1"
      Height          =   1155
      Left            =   180
      TabIndex        =   0
      Top             =   180
      Width           =   2055
      Begin VB.TextBox Text2 
         Height          =   315
         Index           =   1
         Left            =   1200
         TabIndex        =   4
         Text            =   "Text2"
         Top             =   660
         Width           =   675
      End
      Begin VB.TextBox Text2 
         Height          =   315
         Index           =   0
         Left            =   1200
         TabIndex        =   2
         Text            =   "Text2"
         Top             =   240
         Width           =   675
      End
      Begin VB.Label Label2 
         Alignment       =   1  'Right Justify
         AutoSize        =   -1  'True
         Caption         =   "Denominator:"
         Height          =   195
         Index           =   1
         Left            =   135
         TabIndex        =   3
         Top             =   720
         Width           =   945
      End
      Begin VB.Label Label2 
         Alignment       =   1  'Right Justify
         AutoSize        =   -1  'True
         Caption         =   "Numerator:"
         Height          =   195
         Index           =   0
         Left            =   300
         TabIndex        =   1
         Top             =   300
         Width           =   780
      End
   End
   Begin VB.TextBox Text1 
      Height          =   1515
      Left            =   180
      Locked          =   -1  'True
      MultiLine       =   -1  'True
      TabIndex        =   11
      Text            =   "Fraction.frx":0000
      Top             =   1740
      Width           =   2055
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      Caption         =   "Results:"
      Height          =   195
      Left            =   180
      TabIndex        =   10
      Top             =   1500
      Width           =   570
   End
End
Attribute VB_Name = "FRat"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' *************************************************************
'  Copyright 1994-2000, Zane Thomas, http://www.mabry.com
'  Modified by Karl E. Peterson, May 2000, for publication
'  in VBPJ and at http://www.mvps.org/vb/
' *************************************************************
'  Authors grant royalty-free rights to use this code within
'  compiled applications. Selling or otherwise distributing
'  this source code is not allowed without author's express
'  permission.
' *************************************************************
Option Explicit

Private Sub Check1_Click()
   Recalc
End Sub

Private Sub Check2_Click()
   Recalc
End Sub

Private Sub Command1_Click(Index As Integer)
   Select Case Index
      Case 0: Recalc
      Case 1: Unload Me
   End Select
End Sub

Private Sub Form_Load()
   Const n = 0, d = 1
   ' Provide a few defaults:
   '   7/4 & 1/2
   Text2(n).Text = 7
   Text2(d).Text = 4
   Text3(n).Text = 1
   Text3(d).Text = 2
   ' And calc the results.
   Call Recalc
   ' Clear default icon
   Set Me.Icon = Nothing
   ' Bump results fontsize
   Text1.Font.Size = Text1.Font.Size + 2
End Sub

Private Sub Text2_GotFocus(Index As Integer)
   Call Highlight
End Sub

Private Sub Text3_GotFocus(Index As Integer)
   Call Highlight
End Sub

' ************************************************
'  Private Methods
' ************************************************
Private Sub Highlight()
   Dim txt As TextBox
   If TypeOf Me.ActiveControl Is TextBox Then
      Set txt = Me.ActiveControl
      txt.SelStart = 0
      txt.SelLength = Len(txt.Text)
   End If
End Sub

Private Sub Recalc()
   Dim rat1 As New CRat
   Dim rat2 As New CRat
   Dim txt As String
   Dim Whole As Boolean
   Const n = 0, d = 1
   
   ' Read user input
   On Error GoTo BadInput
      rat1.AutoReduce = (Check2.Value = vbChecked)
      rat1.SetValues CLng(Text2(n)), CLng(Text2(d))
      rat2.AutoReduce = (Check2.Value = vbChecked)
      rat2.SetValues CLng(Text3(n)), CLng(Text3(d))
   On Error GoTo 0
   
   ' Either show just fractions, or
   ' whole portion and fraction.
   Whole = (Check1.Value = vbChecked)
   
   ' rat1 + rat2
   txt = rat1.AsString & " + " _
         & rat2.AsString & " = " _
         & rat1.Add(rat2).AsString(Whole) _
         & vbCrLf
   
   ' Print  rat1 - rat2
   txt = txt & rat1.AsString & " - " _
         & rat2.AsString & " = " _
         & rat1.Subtract(rat2).AsString(Whole) _
         & vbCrLf
   
   ' Print rat1 * rat2
   txt = txt & rat1.AsString & " * " _
         & rat2.AsString & " = " _
         & rat1.Multiply(rat2).AsString(Whole) _
         & vbCrLf
   
   ' Print rat1 / rat2
   txt = txt & rat1.AsString & " / " _
         & rat2.AsString & " = " _
         & rat1.Divide(rat2).AsString(Whole) _
         & vbCrLf
   
   Text1.Text = txt
   Exit Sub

BadInput:
   MsgBox "Please insure all values may be " & vbCrLf & _
          "coerced to Longs.", vbExclamation, "Bad Input"
End Sub

